# include <stdio.h>
# include <math.h>
double fx(double x)
{
    return x*x*x*x*x-1.5;
}

double fp(double x)
{
    return 5.0*x*x*x*x;
}

double fp2(double x)
{
    return 20.0*x*x*x;
}

double newtonMethod(double x)
{
    const int maxIters=100;
    int it =0;
    while(it<=maxIters)
    {
        x=x-fx(x)/fp(x);
        printf("Newton[%d]=%lf\n",it,fx(x));
        it++;
        if(fabs(fx(x))<1e-5) break;
    }
    return x;
}

double helleyMethod(double x)
{
    const int maxIters=100;
    int it =0;
    while(it<=maxIters)
    {
        x=x-fx(x)/(fp(x)-(fx(x)*fp2(x))/(2.0*fp(x)));
        printf("Helley[%d]=%lf\n",it,fx(x));
        it++;
        if(fabs(fx(x))<1e-5) break;
    }
    return x;
}

int main()
{
    double x0=3.0;
    double root1=newtonMethod(x0);
    double root2=helleyMethod(x0);
    printf("Roots %lf %lf \n",root1,root2);
    return 0;
}
