# include <math.h>
# include <stdio.h>


double factorial(int n)
{
    double p=1.0;
    for(int i=1;i<=n;i++)
        p = p *i;
    return p;
}
double f(double x)
{
    return x*sin(x*x);
}

double f1(double x)
{
    return sin(x*x)+2*x*x*cos(x*x);
}

double f2(double x)
{
    return 6*x*cos(x*x)-4*x*x*x*sin(x*x);
}

double f3(double x)
{
    return -8*pow(x,4)*cos(x*x)-24*x*x*sin(x*x)+6*cos(x*x);
}

double f4(double x)
{
    return (16*pow(x,5)-60*x)*sin(x*x)-80*pow(x,3)*cos(x*x);
}

double f5(double x)
{
    return (240*pow(x,4)-60)*sin(x*x)+(32*pow(x,6)-360*x*x)*cos(x*x);
}

double f6(double x)
{
    return -64*pow(x,7)*sin(x*x)+672*pow(x,5)*cos(x*x)+1680*pow(x,3)*sin(x*x)
            -840*cos(x*x);
}

double f7(double x)
{
    return -128*pow(x,8)*cos(x*x)-1792*pow(x,6)*sin(x*x)+6720*pow(x,4)*cos(x*x)+
            6720*x*x*sin(x*x)-840*cos(x*x);
}

double f8(double x)
{
    return 256*pow(x,9)*sin(x*x)-4608*pow(x,7)*cos(x*x)-24192*pow(x,5)*sin(x*x)+
            40320*pow(x,3)*cos(x*x)+15120*x*sin(x*x);
}

double f9(double x)
{
    return 512 * pow(x,10)*cos(x*x)+11520*pow(x,8)*sin(x*x)-80640*pow(x,6)*cos(x*x)-
            201600*pow(x,4)*sin(x*x)+151200*x*x*cos(x*x)+15120*sin(x*x);
}

double f10(double x)
{
    return -1024 * pow(x,11)*sin(x*x)+28160*pow(x,9)*cos(x*x)+253440*pow(x,7)*sin(x*x)-
            887040*pow(x,5)*cos(x*x)-1108800*pow(x,3)*sin(x*x)+332640*x*cos(x*x);
}
double taylorFunction(double x,int terms)
{
    const double x0=0;
    double values[]={f(x0),f1(x0),f2(x0),f3(x0),f4(x0),f5(x0),
                       f6(x0),f7(x0),f8(x0),f9(x0),f10(x0)};
    double sum = 0.0;
    for(int i=0;i<=terms;i++)
    {
        double t1 = pow(x-x0,i);
        double t2 = values[i];
        double t3=factorial(i);
        sum = sum + (t1*t2)/t3;
    }
    return sum;
}

int main()
{
    const double a =-1;
    const double b = 1;
    const int npoints = 100;
    double dx = (b-a)/npoints;
    for(double x=a;x<=b;x+=dx)
    {
        printf("%lf %lf %lf \n",x,f(x),taylorFunction(x,10));
    }
    return 0;
}
